package gui.table;
import java.awt.datatransfer.StringSelection;
import java.awt.datatransfer.Transferable;
import java.lang.*;
import java.util.Vector;
import javax.swing.table.DefaultTableModel;
import data.ToPrimitive;
import gui.transfer.TransferableData;

//--------------------------------------------------------------------//
/**
 * We[uf[^fNX
 */
public class BasicTableModel extends DefaultTableModel
  implements Cloneable,TransferableData{

/**
 * s 0  0 ̕We[uf[^f\z
 */
  public BasicTableModel(){
    super();
  }

/**
 * sƗ̐w肵ĕWe[uf[^f\z
 * @param rowCount s̐
 * @param columnCount ̐
 */
  public BasicTableModel(int rowCount,int columnCount){
    super(rowCount,columnCount);
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @param row f[^os
 * @param column f[^o
 * @return w肳ꂽʒũf[^
 */
  public String getStringAt(int row,int column){
    Object value=getValueAt(row,column);
    if(value==null) return "";
    else            return String.valueOf(value);
  }

//--------------------------------------------------------------------//
/**
 * f[^lԂ
 * @param row f[^os
 * @param column f[^o
 * @return w肳ꂽʒũf[^l
 */
  public double getNumberAt(int row,int column){
    return ToPrimitive.doubleValue(getValueAt(row,column));
  }

//--------------------------------------------------------------------//
/**
 * f[^
 */
  public void clear(){
    columnIdentifiers.clear();
    dataVector.clear();
  }

//--------------------------------------------------------------------//
/**
 * ]f[^Ԃ
 * @return ]f[^ <code>Transferable</code> IuWFNg
 */
  public Transferable getContext(){
    return new StringSelection(toString());
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃Rs[Ԃ<br>
 * Ẑ̓Rs[Ȃ
 * @return ̃CX^X̕
 */
  public Object clone(){
    try{
      BasicTableModel model=(BasicTableModel)super.clone();
      model.setDataVector(new Vector(),new Vector());
      int rowCount=getRowCount();
      int columnCount=getColumnCount();
      model.setRowCount(rowCount);
      for(int j=0;j<columnCount;j++){
      	model.addColumn(getColumnName(j));
      }
      for(int i=0;i<rowCount;i++){
      	for(int j=0;j<columnCount;j++){
      	  model.setValueAt(getValueAt(i,j),i,j);
      	}
      }
      return model;
    }
    catch(CloneNotSupportedException ex){
      throw new InternalError();
    }
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃nbVR[hlԂ
 * @return IuWFNg̃nbVR[hl
 */
  public int hashCode(){
    int rowCount=getRowCount();
    int columnCount=getColumnCount();
    int bit=31*rowCount+columnCount;
    for(int i=0;i<rowCount;i++){
      for(int j=0;j<columnCount;j++){
      	Object value=getValueAt(i,j);
      	bit*=31;
      	if(value!=null) bit+=value.hashCode();
      }
    }
    return bit;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @param obj rΏۂ̃IuWFNg
 * @return rΏۂ̃IuWFNgNXɑ
 *         lꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof BasicTableModel){
      BasicTableModel model=(BasicTableModel)obj;
      if(!getClass().toString().equals(model.getClass().toString()))
      	return false;
      int rowCount=model.getRowCount();
      int columnCount=model.getColumnCount();
      if(getRowCount()!=rowCount || getColumnCount()!=columnCount)
      	return false;
      for(int i=0;i<rowCount;i++){
      	for(int j=0;j<columnCount;j++){
      	  Object value1=getValueAt(i,j);
      	  Object value2=model.getValueAt(i,j);
      	  if(value1==null){
      	    if(value2!=null) return false;
      	  }
      	  else if(!value1.equals(value2)){
      	    return false;
      	  }
      	}
      }
      return true;
    }
    return false;
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ<br>
 * Sf[^𕶎\L
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    int rowCount=getRowCount();
    int columnCount=getColumnCount();
    if((rowCount==0) || (columnCount==0)) return "";
    StringBuffer sb=new StringBuffer();
    for(int i=0;i<rowCount;i++){
      for(int j=0;j<columnCount-1;j++){
      	sb.append(getStringAt(i,j));
      	sb.append('\t');
      }
      sb.append(getStringAt(i,columnCount-1));
      sb.append('\n');
    }
    return sb.toString();
  }
}
