package worldmap;
import java.awt.Color;
import java.awt.Component;
import java.lang.*;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.swing.DefaultListModel;
import javax.swing.DefaultListCellRenderer;
import javax.swing.JList;
import javax.swing.event.ListSelectionEvent;
import gui.EditableList;

//--------------------------------------------------------------------//
/**
 * }bv̈惊Xg
 */
public class RegionList extends EditableList{

/** CύXbN */
  public boolean oceanLock;

/** Q}bvf[^f */
  protected WorldMapModel model;

/** C\̈ */
  protected Region ocean;

/**
 * }bv̈惊Xg\z
 * @param model Q}bvf[^f
 */
  public RegionList(WorldMapModel model){
    super();
    this.model=model;
    setCellRenderer(new RegionListCellRenderer());
    ocean=new Region("ocean",Color.BLUE);
    oceanLock=true;
  }

//--------------------------------------------------------------------//
/**
 * I}bv̈ύX
 * @param e ANVƂCxg
 */
  public void valueChanged(ListSelectionEvent e){
    if(!e.getValueIsAdjusting()){
      int index=getSelectedIndex();
      if(oceanLock && (index>=0)) model.setPointer(index+1);
      else                        model.setPointer(index);
    }
  }

//--------------------------------------------------------------------//
/**
 * }bvfĐݒ肷
 * @param oldList ύXÖ̗惊Xg
 */
  protected void resetModel(List oldList){
    Map map=getIndexMap();
    int size=oldList.size();
    int pointer[]=new int[size];
    for(int i=0;i<size;i++){
      Object number=map.get(oldList.get(i));
      if(number instanceof Number){
      	pointer[i]=((Number)number).intValue();
      }
      else{
      	pointer[i]=-1;
      }
    }
    model.resetRegion(pointer);
    model.setColors(getList());
  }

//--------------------------------------------------------------------//
/**
 * vfړ
 * @param beforeIndex vf̈ړÕCfbNX
 * @param afterIndex ړ̃CfbNX
 * @return ړvf
 */
  protected Object moveElement(int beforeIndex,int afterIndex){
    List oldList=getList();
    Object value=super.moveElement(beforeIndex,afterIndex);
    resetModel(oldList);
    return value;
  }

//--------------------------------------------------------------------//
/**
 * XgԂ
 * @return C܂ޗ̈i[Xg
 */
  public List getList(){
    ArrayList list=new ArrayList();
    int size=getRegionCount();
    for(int i=0;i<size;i++){
      list.add(getRegion(i));
    }
    list.trimToSize();
    return list;
  }

//--------------------------------------------------------------------//
/**
 * ̈L[ƂCfbNX}bsO}bvԂ
 * @return ̈L[ƂCfbNX}bsO}bv
 */
  public Map getIndexMap(){
    HashMap map=new HashMap();
    int size=getRegionCount();
    for(int i=0;i<size;i++){
      map.put(getRegion(i),new Integer(i));
    }
    return map;
  }

//--------------------------------------------------------------------//
/**
 * ݑIĂ̈̃CfbNXԂ
 * @return ݑIĂ̈̃CfbNX
 */
  public int getPointer(){
    int index=getSelectedIndex();
    if(oceanLock && (index>=0)) index++;
    return index;
  }

//--------------------------------------------------------------------//
/**
 * CύXbNԂ
 * @return CύXbN bN|Ăꍇ true
 */
  public boolean getOceanLock(){
    return oceanLock;
  }

//--------------------------------------------------------------------//
/**
 * CύXbNݒ肷
 * @param oceanLock CύXbN̐ݒl
 */
  public void setOceanLock(boolean oceanLock){
    clearSelection();
    DefaultListModel listModel=getDefaultListModel();
    this.oceanLock=oceanLock;
    model.setOceanLock(oceanLock);
    if(oceanLock){
      listModel.removeElement(ocean);
    }
    else if(!listModel.contains(ocean)){
      listModel.add(WorldMapModel.OCEAN,ocean);
    }
  }

//--------------------------------------------------------------------//
/**
 * }bv̈̐Ԃ
 * @return }bv̈̐
 */
  public int getRegionCount(){
    int size=getDefaultListModel().getSize();
    if(oceanLock) size++;
    return size;
  }

//--------------------------------------------------------------------//
/**
 * ݑIĂ}bv̈Ԃ
 * @return ݑIĂ}bv̈
 */
  public Region getSelectedRegion(){
    Object value=getSelectedValue();
    if(value instanceof Region){
      return (Region)value;
    }
    else{
      return null;
    }
  }

//--------------------------------------------------------------------//
/**
 * }bv̈Ԃ
 * @param index }bv̈̃CfbNX
 * @return w肳ꂽʒũ}bv̈
 */
  public Region getRegion(int index){
    if(oceanLock){
      if(index==0)     return ocean;
      else if(index>0) index--;
    }
    return (Region)getDefaultListModel().get(index);
  }

//--------------------------------------------------------------------//
/**
 * }bv̈ǉ
 * @param region ǉ}bv̈
 */
  public void addRegion(Region region){
    getDefaultListModel().addElement(region);
  }

//--------------------------------------------------------------------//
/**
 * }bv̈u
 * @param index }bv̈uCfbNX
 * @param region u}bv̈
 */
  public void setRegion(int index,Region region){
    if(index>=0){
      getDefaultListModel().set(index,region);
    }
  }

//--------------------------------------------------------------------//
/**
 * ݑIĂ}bv̈u
 * @param region u}bv̈
 */
  public void setRegion(Region region){
    setRegion(getSelectedIndex(),region);
  }

//--------------------------------------------------------------------//
/**
 * }bv̈ݒ肷
 * @param region ݒ肷}bv̈i[z
 */
  public void setRegions(Region region[]){
    DefaultListModel listModel=getDefaultListModel();
    listModel.clear();
    ocean=region[0];
    for(int i=0;i<region.length;i++){
      if(!oceanLock || !ocean.equals(region[i])){
      	listModel.addElement(region[i]);
      }
    }
    model.setColors(region);
  }

//--------------------------------------------------------------------//
/**
 * ̈폜
 * @param index }bv̈폜CfbNX
 */
  public void removeRegion(int index){
    if(index>=0){
      List oldList=getList();
      getDefaultListModel().remove(index);
      resetModel(oldList);
    }
  }

//--------------------------------------------------------------------//
/**
 * ݑIĂ̈폜
 */
  public void removeRegion(){
    removeRegion(getSelectedIndex());
  }

//--------------------------------------------------------------------//
/**
 * }bv̈惊Xg̃Z`NX
 */
  protected class RegionListCellRenderer
    extends DefaultListCellRenderer{

    protected RegionListCellRenderer(){
      super();
    }

//--------------------------------------------------------------------//
/**
 * }bv̈惊Xg̃Z`ɎgpR|[lg
 * @param list `悷邽߂Ƀ_O߂ JList
 * @param value Z̒l
 * @param index Z̃CfbNX
 * @param isSelected Z̑I
 * @param cellHasFocus Z̃tH[JX
 * @return Z̕`ɎgpR|[lg
 */
    public Component getListCellRendererComponent
      (JList list,Object value,int index,boolean isSelected,
       boolean cellHasFocus){
      if(value instanceof Region){
      	Region region=(Region)value;
      	if(isSelected){
      	  setBackground(list.getSelectionBackground());
      	  setForeground(list.getSelectionForeground());
      	}
      	else{
      	  setBackground(list.getBackground());
      	  setForeground(list.getForeground());
      	}
      	setText(region.getName());
      	setIcon(new RegionIcon(region,list));
      	return this;
      }
      else{
      	return super.getListCellRendererComponent
      	      	 (list,value,index,isSelected,cellHasFocus);
      }
    }
  }
}
